function tvRP.varyHealth(variation)
  local ped = PlayerPedId()
  local n = math.floor(GetEntityHealth(ped)+variation)
  SetEntityHealth(ped,n)
end

function tvRP.getHealth()
  return GetEntityHealth(PlayerPedId())
end

function tvRP.setHealth(health)
  local n = math.floor(health)
  SetEntityHealth(PlayerPedId(), n)
  CreateThread(function()
    Wait(1000)
    SetEntityHealth(PlayerPedId(), n)
  end)
end

CreateThread(function()
  while true do
    Wait(5000)

    if IsPlayerPlaying(_GPLAYER) then
      local ped = _GPED

      local vthirst = 0
      local vhunger = 0

      if IsPedOnFoot(ped) and not tvRP.isNoclip() then
          local factor = math.min(tvRP.getSpeed(), 10)

          vthirst = vthirst + 0.5 * factor
          vhunger = vhunger + 0.5 * factor
      end

      if IsPedInMeleeCombat(ped) then
          vthirst = vthirst + 10
          vhunger = vhunger + 5
      end

      if IsPedHurt(ped) or IsPedInjured(ped) then
          vthirst = vthirst + 2
          vhunger = vhunger + 1
      end

      if vthirst ~= 0  then
          vRPserver.varyThirst({vthirst / 12.0})
      end

      if vhunger ~= 0 then
          vRPserver.varyHunger({vhunger / 12.0})
      end
    end
  end
end)

-- COMA SYSTEM
local in_coma = false
local coma_left = cfg.coma_duration*60
local setRespawnTime = false
local timeToRespawn = false

local function respawnThePlayer()
  local ped = _GPED
  if in_coma then -- get out of coma state
    tick = 0
    CreateThread(function()
      in_coma = false
      setRespawnTime = false

      while GetEntityHealth(ped)-1 <= cfg.coma_threshold do
        Wait(1)

        break
      end

      SetEntityInvincible(ped,false)
      tvRP.setRagdoll(false)
      tvRP.stopScreenEffect(cfg.coma_effect)

      TriggerEvent("BlueLifeDeathScreen:SetDeath", 'OFF')

      if coma_left <= 0 then -- get out of coma by death
        if GetEntityHealth(ped)-1 <= cfg.coma_threshold then
          SetEntityHealth(ped, 0)
      
          CreateThread(function()
            Wait(500)
            TriggerEvent("BlueLifeDeathScreen:SetDeath", 'OFF')
            exports['vrp']:spawnPlayer()
            CancelEvent();
          end)
        end
      end

      SetTimeout(5000, function()  -- able to be in coma again after coma death after 5 seconds
        coma_left = cfg.coma_duration*60
      end)
    end)
  end
end

local function selfRespawn()
  if timeToRespawn then
    if timeToRespawn <= GetGameTimer() then
      tvRP.killComa()
    end
  end
end

CreateThread(function() -- coma thread
  while true do
    tick = 500
    local ped = PlayerPedId()

    if in_coma then
      tick = 0

      if not setRespawnTime then
        setRespawnTime = true
        timeToRespawn = GetGameTimer()  + (5 * 60 * 1000)
        TriggerEvent("BlueLifeDeathScreen:SetButon", "OFF");
        TriggerEvent("onComaEntered")
      end

      TriggerEvent("BlueLifeDeathScreen:SetDeath", 'ON')

      if timeToRespawn > GetGameTimer() then
        TriggerEvent("BlueLifeDeathScreen:SetDeathTime", string.format("%03d", coma_left));
      else
        TriggerEvent("BlueLifeDeathScreen:SetDeathTime", string.format("%03d", coma_left));
        TriggerEvent("BlueLifeDeathScreen:SetButon", "ON");
        if IsControlJustPressed(0, 22) then
          selfRespawn()
        end
      end

		  DisableControlAction(0,24, true) -- disable attack
	    DisableControlAction(0,25, true) -- disable aim
    elseif timeToRespawn then
      timeToRespawn = false
    end
    
    local health = GetEntityHealth(ped) or 0
    if health <= cfg.coma_threshold and coma_left > 0 then
        tick = 0
        if not in_coma then -- go to coma state
          if IsEntityDead(ped) then -- if dead, resurrect
            local x,y,z = tvRP.getPosition()
            NetworkResurrectLocalPlayer(x, y, z, true, true, false)
            Wait(0)
          end

          -- coma state
          in_coma = true
          vRPserver.updateHealth({cfg.coma_threshold}) -- force health update
          SetEntityHealth(ped, cfg.coma_threshold)
          SetEntityInvincible(ped,true)
          tvRP.playScreenEffect(cfg.coma_effect,-1)
          tvRP.ejectVehicle()
          tvRP.setRagdoll(true)
        else -- in coma
          -- maintain life
          if health < cfg.coma_threshold then 
            SetEntityHealth(ped, cfg.coma_threshold) 
          end
        end
    else
      respawnThePlayer()
    end
    Wait(tick)
  end
end)

function tvRP.isInComa()
  return in_coma
end

-- kill the player if in coma
function tvRP.killComa()
  if in_coma then
    coma_left = 0
  end
end

CreateThread(function() -- coma decrease thread  
  while true do
    Wait(1000)
    SetPlayerHealthRechargeMultiplier(_GPLAYER, 0.0)
    
    if in_coma then
      coma_left = coma_left-1
    end
  end
end)


local weaponNames = {
    ["weapon_dagger"] = "Dagger",
    ["weapon_bat"] = "Bat",
    ["weapon_bottle"] = "Bottle",
    ["weapon_crowbar"] = "Crowbar",
    ["weapon_unarmed"] = "Fist",
    ["weapon_flashlight"] = "Flashlight",
    ["weapon_golfclub"] = "Golf Club",
    ["weapon_hammer"] = "Hammer",
    ["weapon_hatchet"] = "Hatchet",
    ["weapon_knuckle"] = "Knuckle",
    ["weapon_knife"] = "Knife",
    ["weapon_machete"] = "Machete",
    ["weapon_switchblade"] = "Switchblade",
    ["weapon_nightstick"] = "Nightstick",
    ["weapon_wrench"] = "Wrench",
    ["weapon_battleaxe"] = "Battle Axe",
    ["weapon_poolcue"] = "Poolcue",
    ["weapon_stone_hatchet"] = "Stone Hatchet",
    ["weapon_pistol"] = "Pistol",
    ["weapon_pistol_mk2"] = "Pistol MK2",
    ["weapon_combatpistol"] = "Combat Pistol",
    ["weapon_appistol"] = "AP Pistol",
    ["weapon_stungun"] = "Stungun",
    ["weapon_pistol50"] = "Pistol .50",
    ["weapon_snspistol"] = "SNS Pistol",
    ["weapon_snspistol_mk2"] = "SNS Pistol MK2",
    ["weapon_heavypistol"] = "Heavy Pistol",
    ["weapon_vintagepistol"] = "Vintage Pistol",
    ["weapon_flaregun"] = "Flare Gun",
    ["weapon_marksmanpistol"] = "Marksman Pistol",
    ["weapon_revolver"] = "Revolver",
    ["weapon_revolver_mk2"] = "Revolver MK2",
    ["weapon_doubleaction"] = "Double Action Revolver",
    ["weapon_raypistol"] = "Ray Pistol",
    ["weapon_ceramicpistol"] = "Ceramic Pistol",
    ["weapon_navyrevolver"] = "Navy Revolver",
    ["weapon_microsmg"] = "Micro SMG",
    ["weapon_smg"] = "SMG",
    ["weapon_smg_mk2"] = "SMG MK2",
    ["weapon_assaultsmg"] = "Assault SMG",
    ["weapon_combatpdw"] = "Combat PDW",
    ["weapon_machinepistol"] = "Machine Pistol",
    ["weapon_minismg"] = "Mini SMG",
    ["weapon_raycarbine"] = "Ray Carbine",
    ["weapon_pumpshotgun"] = "Pump Shotgun",
    ["weapon_pumpshotgun_mk2"] = "Pump Shotgun MK2",
    ["weapon_sawnoffshotgun"] = "Sawn-Off Shotgun",
    ["weapon_assaultshotgun"] = "Assault Shotgun",
    ["weapon_bullpupshotgun"] = "Bullpup Shotgun",
    ["weapon_musket"] = "Musket",
    ["weapon_heavyshotgun"] = "Heavy Shotgun",
    ["weapon_dbshotgun"] = "Double Barrel Shotgun",
    ["weapon_autoshotgun"] = "Auto Shotgun",
    ["weapon_assaultrifle"] = "Assault Rifle",
    ["weapon_assaultrifle_mk2"] = "Assault Rifle MK2",
    ["weapon_carbinerifle"] = "Carbine Rifle",
    ["weapon_carbinerifle_mk2"] = "Carbine Rifle MK2",
    ["weapon_advancedrifle"] = "Advanced Rifle",
    ["weapon_specialcarbine"] = "Special Carbine",
    ["weapon_specialcarbine_mk2"] = "Special Carbine MK2",
    ["weapon_bullpuprifle"] = "Bullpup Rifle",
    ["weapon_bullpuprifle_mk2"] = "Bullpup Rifle MK2",
    ["weapon_compactrifle"] = "Compact Rifle",
    ["weapon_mg"] = "MG",
    ["weapon_combatmg"] = "Combat MG",
    ["weapon_combatmg_mk2"] = "Combat MG MK2",
    ["weapon_gusenberg"] = "Gusenberg",
    ["weapon_sniperrifle"] = "Sniper Rifle",
    ["weapon_heavysniper"] = "Heavy Sniper",
    ["weapon_heavysniper_mk2"] = "Heavy Sniper MK2",
    ["weapon_marksmanrifle"] = "Marksman Rifle",
    ["weapon_marksmanrifle_mk2"] = "Marksman Rifle MK2",
    ["weapon_rpg"] = "RPG",
    ["weapon_grenadelauncher"] = "Grenade Launcher",
    ["weapon_grenadelauncher_smoke"] = "Grenade Launcher Smoke",
    ["weapon_minigun"] = "Minigun",
    ["weapon_firework"] = "Firework Launcher",
    ["weapon_railgun"] = "Railgun",
    ["weapon_hominglauncher"] = "Homing Launcher",
    ["weapon_compactlauncher"] = "Compact Grenade Launcher",
    ["weapon_rayminigun"] = "Ray Minigun",
    ["weapon_grenade"] = "Grenade",
    ["weapon_bzgas"] = "BZ-Gas",
    ["weapon_smokegrenade"] = "Smoke Grenade",
    ["weapon_flare"] = "Flare",
    ["weapon_molotov"] = "Molotov",
    ["weapon_stickybomb"] = "Sticky Bomb",
    ["weapon_proxmine"] = "Proxmine Mines",
    ["weapon_snowball"] = "Snowball",
    ["weapon_pipebomb"] = "Pipebomb",
    ["weapon_ball"] = "Ball",
    ["weapon_petrolcan"] = "Petrol Can",
    ["weapon_fireextinguisher"] = "Fire Extinguisher",
    ["weapon_parachute"] = "Parachute",
    ["weapon_hazardcan"] = "Hazadous Petrol Can"
}

AddEventHandler("gameEventTriggered", function(name, args)
    if name == "CEventNetworkEntityDamage" then
        local victim = args[1]
        local attacker = args[2]
        local victimDied = args[3]
        local ped = _GPED
        local health = GetEntityHealth(_GPED)
        if not in_coma then
            if victim == _GPED and victimDied then
                if health <= cfg.coma_threshold then
                    local _, lastDamagedBone = GetPedLastDamageBone(victim)
                    local attackerPedId, attackerId, attackerServerId = attacker, NetworkGetPlayerIndexFromPed(attacker), GetPlayerServerId(NetworkGetPlayerIndexFromPed(attacker))
                    local weaponHash, weaponName = args[7], nil

                    local isHeadshot = (tonumber(lastDamagedBone) == 31086)
                    local killedHimself = (tonumber(attackerPedId) == -1)
                    local killedByVehicle = false

                    if weaponNames[args[7]] then
                        weaponName = weaponNames[args[7]]
                    else
                        if tonumber(args[7]) == -1553120962 then
                            local vehicle = GetVehiclePedIsIn(attackerPedId, false)
                            if DoesEntityExist(vehicle) then
                                local vehicleModel = GetEntityModel(vehicle)
                                local vehicleName = GetDisplayNameFromVehicleModel(vehicleModel)
                                local plate = GetVehicleNumberPlateText(vehicle)
                                weaponName = vehicleName.." (plate: "..plate..")"
                            else
                                weaponName = "Unknown Vehicle"
                            end
                            killedByVehicle = true
                        else
                            weaponName = args[7]
                        end
                    end
                    TriggerServerEvent("server:playerDead", killedHimself, killedByVehicle, attackerServerId, weaponName, isHeadshot)
                end
            end
        end
    end
end)